/*******************************************/
/*  Raw Wave File Output Class,            */
/*  by Perry R. Cook, 1995-96              */ 
/*  For now, This Object can open a raw    */
/*  16bit data (signed integers) file, and */
/*  poke buffers of samples into it.       */
/*******************************************/

/*******************************************/
/*  SGI Real-Time Wave File Output Class,  */
/*  by Perry R. Cook, 1995-96              */ 
/*  This Object can open the SGI soundout  */
/*  device, and pokes buffers of samples   */
/*  into it.  The real code that does the  */
/*  work is from Doug Scott of SGI.        */
/*******************************************/

/*******************************************/
/*  Wave file Output Class,                */
/*  by Perry R. Cook, 1995-96              */ 
/*  This Object opens a DOS/Windows .wav   */
/*  16bit data (signed integers) file, and */
/*  poke buffers of samples into it.       */
/*******************************************/


#include "Object.h"

#if !defined(__RawWvOut_h)
#define __RawWvOut_h

#if defined(__NeXT_)

#define BUFFER_SIZE 1

class RawWvOut : public Object
{
  protected:  
    FILE *fd;
    short data[BUFFER_SIZE];
    long counter;
    long totalCount;
  public:
    RawWvOut(char *fileName);
    ~RawWvOut();
    long getCounter();
    MY_FLOAT getTime();
    void tick(MY_FLOAT sample);
};

#endif

#if defined(__SGI_REALTIME_)

#define BUFFER_SIZE 128

class RawWvOut : public Object
{
  protected:  
    FILE *fd;
    short data[BUFFER_SIZE];
    long counter;
  public:
    RawWvOut(char *fileName);
    ~RawWvOut();
    void tick(MY_FLOAT sample);
};

#endif

#if defined(__WIN95_REALTIME_)

#define BUFFER_SIZE 4096

class RawWvOut : public Object
{
  protected:
     long counter;
  public:
    RawWvOut(char *fileName);
    ~RawWvOut();
    void tick(MY_FLOAT sample);
};

#endif

#if defined(__DOS_WAV_)

#define BUFFER_SIZE 128

class RawWvOut : public Object
{
  protected:
    FILE *fd;
    short data[BUFFER_SIZE];
    long counter;
    long totalCount;
  public:
    RawWvOut(char *fileName);
    ~RawWvOut();
    long getCounter();
    MY_FLOAT getTime();
    void tick(MY_FLOAT sample);
};

#endif

#endif
